Skip to content

Overview

  • Version: 1.0.0
  • Servers: https://login.xsolla.com/api
  • Protocols: https
  • Accepts: application/json
  • Responds with: application/json
  • Contact us by email
  • Contact URL: https://xsolla.com/

This section describes API calls for working with Login. Set up your Login project in Publisher Account before sending requests.

IP addresses

The full list of IP addresses that login.xsolla.com may use:

  • 34.94.0.85
  • 34.94.14.95
  • 34.94.25.33
  • 34.94.115.185
  • 34.94.154.26
  • 34.94.173.132
  • 34.102.48.30
  • 35.235.99.248
  • 35.236.32.131
  • 35.236.35.100
  • 35.236.117.164

Glossary

You have access to the following Login project types in Publisher Account:

  • Standard Login project
  • Shadow Login project

To find more information on it, see Cross-platform account feature.

Rate limits

Are the restrictions applied by Xsolla API on the frequency of access by a user within a defined timeframe.

Standard Login project

Is a Login project that is used to store main accounts.

Shadow Login project

Is a Login project that is used to store platform accounts.

Main account

Is an account type that is created in a standard Login project and linked to platform accounts. The main account is used to identify the player on different platforms.

Platform account

Is an account type that is created in a shadow Login project and connected to a definite publishing platform. The platform account can't be linked to another platform account. Also, you can't unlink the accounts from a main account.

Publishing platform

Is a game platform that is used for game distribution (e.g. Steam, PlayStation, Xbox, etc.).

Authentication

Login API supports the following token types:

Authentication schemes

You can determine whether an API call is client or server-side by the scheme of authentication:

  • Client-side — are called without authentication or with the Authorization header: Bearer <user_JWT> header, where <user_JWT> — is the user token.
  • Server-side API calls for implementing the user flow — are called with the header: X-SERVER-AUTHORIZATION: <server_JWT>, where <server_JWT> — is the server token.

Getting a user token

To get the token, send one of the following requests:

After JWT authentication, the user is redirected to the Callback URL with a token in a query-parameter: <Callback URL>?token=<User token (JWT)>.

After OAuth 2.0 protocol-based authentication, send the Generate JWT POST request to the Xsolla Login server to exchange the received code parameter for a user token (access_token).

When the access token expires, the client sends Generate JWT POST request endpoint on the Xsolla Login server. The request body must include the following parameters:

  • grant_type — JWT grant type, pass the refresh_token value.
  • client_id — OAuth 2.0 client ID.
  • refresh_token — refresh token received in response to the user authorization request.

Getting a server token

To get a server token:

Set up server OAuth 2.0 client

  1. Open your project in Publisher Account and go to the Login section.
  2. Click Configure in the panel of a Login project.
  3. Go to the Security block and select the OAuth 2.0 section.
  4. Click Add OAuth 2.0 Client.
  5. Check the Server (server-to-server connection) box.
  6. Specify Token lifetime.
  7. Click Connect.
  8. Copy and save the client ID and secret key.

Generate server JWT

On the back end of your application, implement a method to get the server JWT using the Generate JWT API call. The request must contain the following parameters:

  • grant_type is the type of getting JWT, pass the client_credentials value.
  • client_secret is the secret key that is received when you set up the server OAuth 2.0 client.
  • client_id is the client ID received when you set up the server OAuth 2.0 client.

When the server token expires, generate a new token using the Generate JWT API call. The request body must include the following parameters:

  • grant_type — JWT grant type, pass the client_credentials value.
  • client_id — OAuth 2.0 client ID.
  • client_secret — OAuth 2.0 client secret key.

Rate limits

To prevent Xsolla system overloads and protect against sudden spikes in incoming traffic, Xsolla limits the number of requests received by the Xsolla API within a specified period of time. If the limit is exceeded, the Xsolla API returns an HTTP response with the 429 status code.

Rate limits vary by method, IP-address, authentication scheme, and other factors.

Rate limits for server-side methods are applied to methods with server-side authentication — methods that are called with the X-SERVER-AUTHORIZATION: <server_JWT> header, where <server_JWT> is the server token.

Rate limits for client-side methods are applied to methods without authentication or with client-side authentication — methods that are called with the Authorization: Bearer <user_JWT> header, where <user_JWT> is the user token.

Example of a method with server-side authentication: Example of a method with server-side authentication Example of a method with client-side authentication: Example of a method with server-side authentication

Rate limits for client-side methods do not change and are necessary to prevent brute-force attacks. The maximum request rate for server-side methods is higher than for client-side methods. You can refer to the recommendations on how to manage rate limits in the documentation.

Note

In certain cases, it is possible to adjust the rate limits by request. To request the rate limits adjustment, contact your Customer Success Manager or email csm@xsolla.com.

JWT structure

Every token has a JWT format and contains a definite information in a payload.

User JWT

User JWT is a token received as a result of authentication or registration. A token payload contains information about the user and authentication call.

Getting a user token via the OAuth 2.0 protocol requires an OAuth 2.0 client. The user token is passed in the Authorization: Bearer <JWT> header.

Main claims

A token will contain the main claims after authentication or email address confirmation. Presence of these claims does not depend on the user database and authentication call.

ClaimTypeRequiredDescription
expUnix TimestampYesDate and time of token expiration. Default expiration time is 24 hours. You can change expiration time for every Login project.
issstringYesService that signed the token: https://login.xsolla.com.
iatUnix TimestampYesDate and time of giving the token.
substring (UUID)YesUser ID written on the Xsolla Login server side.
groupsarrayYesList of groups the user is in. Each group: id — group ID; name — group name; is_default — whether the group is default (true or false). There can be only one default group, which initially includes all users before they are distributed into different groups.
xsolla_login_project_idstring (UUID)YesLogin project ID.
typestringAuthentication option: xsolla_login — login via username/email and password; social — social login; email — passwordless login via one-time code by email; phone — by SMS; firebase — Firebase storage; playfab — PlayFab storage; proxy — custom storage; device — device ID; server_custom_id — custom ID.
avatarstringUser avatar URL.
usernamestringUsername.
publisher_idintegerID of a merchant who owns a Login project.
emailstringUser email address.
payloadstringAdditional information that is passed in the payload parameter during authentication.
promo_email_agreementbooleantrue if the user agrees to receive a newsletter, false otherwise. Default: true. To add to the Login widget registration form: contact your Account Manager (Widget 2.0) or add the fields parameter with the promo_email_agreement value to the initialization code (previous widget version).
connection_informationstringShows whether the user confirmed their birth date or not. Confirmation is made via the okname service.

PlayFab storage

Claims that are contained in the token after authentication if you use PlayFab storage.

ClaimTypeRequiredDescription
external_account_idstringYesUser PlayFab ID.
session_ticketstringYesA SessionTicket parameter received during an authentication request or requests to the PlayFab API. A token contains the claim if you authenticate users via the OAuth 2.0 protocol and pass the playfab value to the scope parameter.
entity_tokenstringYesAn EntityToken.EntityToken parameter.
entity_typestringYesAn EntityToken.Entity.Type parameter. Can have only the title_player_account value.
entity_idstringYesAn EntityToken.Entity.Id parameter.

Custom storage

Claims that are contained in the token after authentication if you use custom storage.

ClaimTypeRequiredDescription
providerstringYesName of a social network used for authentication. If the user authenticates via username and password, the claim has the xsolla value.
external_account_idstringUser ID on your server side.
partner_dataData of any type returned by your server in the response body during authentication. To enable the transmission of this claim, contact your Customer Success Manager or email csm@xsolla.com.
social_access_tokenAccess token of the social network through which the user was authenticated. To enable the transmission of this claim, contact your Customer Success Manager or email csm@xsolla.com.

Social authentication

Claims that are contained in the token after authentication via a social network. Presence of these claims does not depend on the user database.

ClaimTypeRequiredDescription
providerstringYesName of a social network used for authentication.
idstringYesUser ID in a social network.
is_cross_authbooleanShows that the silent authentication request is in progress.
social_access_tokenstringSocial network account access_token parameter used for authentication. Contact your Account Manager to set up the feature.
picturestring (URL)Link to the user profile picture in a social network.
birthdaydate (RFC3339)User birth date in a social network.
genderstringUser gender in a social network.
namestringUser nickname in a social network.

Authentication via the OAuth 2.0 protocol

Claims that are contained in the token after OAuth 2.0 authentication.

ClaimTypeRequiredDescription
jtistringYesUnique token ID.

Authentication via a phone number

Claim which is contained in the token after authentication via a phone number.

ClaimTypeRequiredDescription
phone_numberstringYesUser's phone number used for authentication. The phone number format based on the country code, area code, and line number without any dividers.

Server JWT

The server token is passed in the X-SERVER-AUTHORIZATION header.

The token payload contains information about resources owned by the OAuth 2.0 client. The token has access to calls with server-based authentication for these resources.

ClaimTypeRequiredDescription
xsolla_login_project_idstring (UUID)YesID of a Login project that owns the OAuth 2.0 client.
resourcesarrayYesList of resources owned by an OAuth 2.0 client. Possible types: publisher_id — resources of a merchant who owns the Login project; publisher_project_id — resources of a project in Publisher Account. Each resource: name — resource type; value — resource ID.
jtistringYesUnique token ID.

JWT validation

To validate the JWT, use the following Login API calls:

Notice

Do not reveal your secret key to anyone. If it was compromised, please update it.

Errors

Refer to the documentation for information about Xsolla Login API errors.

Download OpenAPI description
Languages
Servers
Mock server
https://xsolla.redocly.app/_mock/api/login/
https://login.xsolla.com/api/
Operations
Operations
Operations
Operations
Operations
Operations

Update user's two-factor authentication settings

Request

Updates user's two-factor authentication settings from server.

Security
Server
Path
user_idstring(uuid)required
project_idstring(uuid)required
Bodyapplication/jsonrequired
change_restrictedboolean

Status of two-factor authentication change restriction. Set true value for enabling, and false value otherwise.

Default false
Example: true
enabledboolean

Status of two-factor authentication settings. Set true value for enabling, and false value otherwise.

Default false
Example: true
mfa_typestringrequired

Type of the second factor. You must enable the specified type for the Login project. Contact your Customer Success Manager to set it up.

Value"email"
Example: "email"
curl --request POST \
  --url https://login.xsolla.com/api/projects/{project_id}/users/{user_id}/mfa \
  --header 'X-SERVER-AUTHORIZATION: YOUR_SERVER_TOKEN' \
  --data '{"change_restricted":true,"enabled":true,"mfa_type":"email"}'

Responses

OK

Response
No content

Get user’s two-factor authentication settings

Request

Gets user’s two-factor authentication settings. You must enable two-factor authentication for the Login project. Contact your Customer Success Manager to enable it.

Security
Bearer
curl --request GET \
  --url https://login.xsolla.com/api/users/me/mfa \
  --header 'Authorization: Bearer BEARER_TOKEN'

Responses

OK

Bodyapplication/jsonArray [
change_restrictedbooleanrequired

Shows whether the user can change the settings or not.

enabledbooleanrequired

Status of two-factor authentication settings.

mfa_typestringrequired

Type of the second factor. You must enable the specified type for the Login project. Contact your Customer Success Manager to set it up.

Value"email"
]
Response
application/json
[ { "change_restricted": false, "enabled": true, "mfa_type": "email" } ]

Update user’s two-factor authentication settings

Request

Updates user’s two-factor authentication settings. The user must confirm the changes by entering a one-time code.

The workflow of using this call:

  1. The user enables or disables two-factor authentication.
  2. The application sends the request to the Xsolla Login server.
  3. The Xsolla Login server sends the one-time confirmation code to the user and returns the URL of the two-factor authentication page.
  4. The application redirects the user to the URL.
  5. The user enters the one-time code.
  6. New two-factor authentication settings are applied.

You must enable two-factor authentication for the Login project. Contact your Customer Success Manager to enable it.

Security
Bearer
Query
login_urlstring

URL to redirect the user to after account confirmation, successful authentication, two-factor authentication configuration, or password reset confirmation. Must be identical to the Callback URL specified in the URL block of Publisher Account. For the scenario of a login error, the value should be identical to the the Error callback URL specified in the URL block of Publisher Account. To find the settings, go to Login > your Login project and select the Callback URLs section in the upper block. Required if there are several Callback URLs.

Bodyapplication/jsonrequired
enabledboolean

Status of two-factor authentication settings. Set true value for enabling, and false value otherwise.

Default false
Example: true
localestring

Region in the <language code>_<country code> format, where:

mfa_typestringrequired

Type of the second factor. You must enable the specified type for the Login project. Contact your Customer Success Manager to set it up.

Value"email"
Example: "email"
curl --request POST \
  --url 'https://login.xsolla.com/api/users/me/mfa?login_url=SOME_STRING_VALUE' \
  --header 'Authorization: Bearer BEARER_TOKEN' \
  --data '{"enabled":true,"mfa_type":"email"}'

Responses

OK

Bodyapplication/json
object

URL of the two-factor authentication page.

Response
application/json
{ "url": "https://xl-widget.xsolla.com/otp?projectId=c7569172-bd62-11e8-a7b5-0242ac111112&challenge_id=0ad73aba-e378-43bb-97c9-0e70af86b2f4&email=lo%2A%2A%2Ar5%40m%2A%2A%2Al.ru" }
Operations
Operations
Operations
Operations
Operations
Operations
Operations
Operations
Operations
Operations
Operations
Operations
Operations
Operations
Operations
Operations
Operations
Operations
Operations